<?php

/*
 * ユニットが持つテーブルの生成を行う
 * @param tbl_unitのマスタ情報
 * テーブル名は extunit_○○○○（拡張ユニットのフォルダ名）とする
 */
function extunit_install($param, $db) {
	switch(DBTYPE) {
		case 'pgsql':
				$sql[] = "CREATE TABLE extunit_extcatlist4 (
        pageu_code integer NOT NULL DEFAULT '0',
        catlist_sidx_code integer DEFAULT NULL,
        catlist_cat_code text,
        catlist_label_code text,
        catlist_layout_pc smallint DEFAULT NULL,
        catlist_layout_sp smallint DEFAULT NULL,
        catlist_s_count integer DEFAULT NULL,
        catlist_limit integer DEFAULT NULL,
        catlist_pflg smallint DEFAULT '1',
        catlist_date_flg smallint DEFAULT '1',
        catlist_date_format text,
        catlist_rss smallint DEFAULT '1',
        catlist_new_flg smallint DEFAULT '1',
        catlist_comment_flg smallint DEFAULT '1',
        catlist_comming_flg smallint DEFAULT '0',
        catlist_new_days integer DEFAULT NULL,
        catlist_order smallint DEFAULT '1',
        catlist_sp_layout smallint NOT NULL DEFAULT '0',
        catlist_comming_text text,
        catlist_nodata_text text,
        catlist_link_text text,
        catlist_nophoto_img text,
        catlist_newicon_img text,
        catlist_effect text,
        catlist_speed smallint DEFAULT '1000',
        catlist_easing text,
        catlist_pager_flg smallint DEFAULT '0',
        catlist_pager_text text,
        catlist_pager_img text,
        catlist_pager_img_hover text,
        catlist_body_charcnt smallint DEFAULT '0',
        catlist_image_height text,
        catlist_object_height text,
        catlist_margin text,
        catlist_column smallint DEFAULT '1',
        catlist_outside_flg smallint DEFAULT '1',
        catlist_outside_color text,
        catlist_outside_weight text,
        catlist_default_bgcolor text,
        catlist_hovered_bgcolor text,
        catlist_color text,
        catlist_color_hover text,
        catlist_hover_effect text,
        catlist_auto_centering smallint DEFAULT '0',
        use_sp_flg smallint DEFAULT '1',
        use_pc_flg smallint DEFAULT '1',
        bg_color smallint DEFAULT '0',
        bdr_type smallint DEFAULT '0',
        btm_padding smallint DEFAULT '2',
        bg_color_sp smallint DEFAULT '0',
        bdr_type_sp smallint DEFAULT '0',
        btm_padding_sp smallint DEFAULT '2',
        primary key (pageu_code)
				);";
				$sql[] = "CREATE TABLE extunit_extcatlist4_tmp (
        pageu_code integer NOT NULL DEFAULT '0',
        catlist_sidx_code integer DEFAULT NULL,
        catlist_cat_code text,
        catlist_label_code text,
        catlist_layout_pc smallint DEFAULT NULL,
        catlist_layout_sp smallint DEFAULT NULL,
        catlist_s_count integer DEFAULT NULL,
        catlist_limit integer DEFAULT NULL,
        catlist_pflg smallint DEFAULT '1',
        catlist_date_flg smallint DEFAULT '1',
        catlist_date_format text,
        catlist_rss smallint DEFAULT '1',
        catlist_new_flg smallint DEFAULT '1',
        catlist_comment_flg smallint DEFAULT '1',
        catlist_comming_flg smallint DEFAULT '0',
        catlist_new_days integer DEFAULT NULL,
        catlist_order smallint DEFAULT '1',
        catlist_sp_layout smallint NOT NULL DEFAULT '0',
        catlist_comming_text text,
        catlist_nodata_text text,
        catlist_link_text text,
        catlist_nophoto_img text,
        catlist_newicon_img text,
        catlist_effect text,
        catlist_speed smallint DEFAULT '1000',
        catlist_easing text,
        catlist_pager_flg smallint DEFAULT '0',
        catlist_pager_text text,
        catlist_pager_img text,
        catlist_pager_img_hover text,
        catlist_body_charcnt smallint DEFAULT '0',
        catlist_image_height text,
        catlist_object_height text,
        catlist_margin text,
        catlist_column smallint DEFAULT '1',
        catlist_outside_flg smallint DEFAULT '1',
        catlist_outside_color text,
        catlist_outside_weight text,
        catlist_default_bgcolor text,
        catlist_hovered_bgcolor text,
        catlist_color text,
        catlist_color_hover text,
        catlist_hover_effect text,
        catlist_auto_centering smallint DEFAULT '0',
        use_sp_flg smallint DEFAULT '1',
        use_pc_flg smallint DEFAULT '1',
        bg_color smallint DEFAULT '0',
        bdr_type smallint DEFAULT '0',
        btm_padding smallint DEFAULT '2',
        bg_color_sp smallint DEFAULT '0',
        bdr_type_sp smallint DEFAULT '0',
        btm_padding_sp smallint DEFAULT '2',
        primary key (pageu_code)
				);";
			break;

			case "mysql":
				$sql[] = "CREATE TABLE extunit_extcatlist4 (
        pageu_code integer NOT NULL DEFAULT '0',
        catlist_sidx_code integer DEFAULT NULL,
        catlist_cat_code text,
        catlist_label_code text,
        catlist_layout_pc smallint DEFAULT NULL,
        catlist_layout_sp smallint DEFAULT NULL,
        catlist_s_count integer DEFAULT NULL,
        catlist_limit integer DEFAULT NULL,
        catlist_pflg smallint DEFAULT '1',
        catlist_date_flg smallint DEFAULT '1',
        catlist_date_format text,
        catlist_rss smallint DEFAULT '1',
        catlist_new_flg smallint DEFAULT '1',
        catlist_comment_flg smallint DEFAULT '1',
        catlist_comming_flg smallint DEFAULT '0',
        catlist_new_days integer DEFAULT NULL,
        catlist_order smallint DEFAULT '1',
        catlist_sp_layout smallint NOT NULL DEFAULT '0',
        catlist_comming_text text,
        catlist_nodata_text text,
        catlist_link_text text,
        catlist_nophoto_img text,
        catlist_newicon_img text,
        catlist_effect text,
        catlist_speed smallint DEFAULT '1000',
        catlist_easing text,
        catlist_pager_flg smallint DEFAULT '0',
        catlist_pager_text text,
        catlist_pager_img text,
        catlist_pager_img_hover text,
        catlist_body_charcnt smallint DEFAULT '0',
        catlist_image_height text,
        catlist_object_height text,
        catlist_margin text,
        catlist_column smallint DEFAULT '1',
        catlist_outside_flg smallint DEFAULT '1',
        catlist_outside_color text,
        catlist_outside_weight text,
        catlist_default_bgcolor text,
        catlist_hovered_bgcolor text,
        catlist_color text,
        catlist_color_hover text,
        catlist_hover_effect text,
        catlist_auto_centering smallint DEFAULT '0',
        use_sp_flg smallint DEFAULT '1',
        use_pc_flg smallint DEFAULT '1',
        bg_color smallint DEFAULT '0',
        bdr_type smallint DEFAULT '0',
        btm_padding smallint DEFAULT '2',
        bg_color_sp smallint DEFAULT '0',
        bdr_type_sp smallint DEFAULT '0',
        btm_padding_sp smallint DEFAULT '2',
        primary key (pageu_code)
				)TYPE = InnoDB DEFAULT CHARSET=utf8;";
				$sql[] = "CREATE TABLE extunit_extcatlist4_tmp (
        pageu_code integer NOT NULL DEFAULT '0',
        catlist_sidx_code integer DEFAULT NULL,
        catlist_cat_code text,
        catlist_label_code text,
        catlist_layout_pc smallint DEFAULT NULL,
        catlist_layout_sp smallint DEFAULT NULL,
        catlist_s_count integer DEFAULT NULL,
        catlist_limit integer DEFAULT NULL,
        catlist_pflg smallint DEFAULT '1',
        catlist_date_flg smallint DEFAULT '1',
        catlist_date_format text,
        catlist_rss smallint DEFAULT '1',
        catlist_new_flg smallint DEFAULT '1',
        catlist_comment_flg smallint DEFAULT '1',
        catlist_comming_flg smallint DEFAULT '0',
        catlist_new_days integer DEFAULT NULL,
        catlist_order smallint DEFAULT '1',
        catlist_sp_layout smallint NOT NULL DEFAULT '0',
        catlist_comming_text text,
        catlist_nodata_text text,
        catlist_link_text text,
        catlist_nophoto_img text,
        catlist_newicon_img text,
        catlist_effect text,
        catlist_speed smallint DEFAULT '1000',
        catlist_easing text,
        catlist_pager_flg smallint DEFAULT '0',
        catlist_pager_text text,
        catlist_pager_img text,
        catlist_pager_img_hover text,
        catlist_body_charcnt smallint DEFAULT '0',
        catlist_image_height text,
        catlist_object_height text,
        catlist_margin text,
        catlist_column smallint DEFAULT '1',
        catlist_outside_flg smallint DEFAULT '1',
        catlist_outside_color text,
        catlist_outside_weight text,
        catlist_default_bgcolor text,
        catlist_hovered_bgcolor text,
        catlist_color text,
        catlist_color_hover text,
        catlist_hover_effect text,
        catlist_auto_centering smallint DEFAULT '0',
        use_sp_flg smallint DEFAULT '1',
        use_pc_flg smallint DEFAULT '1',
        bg_color smallint DEFAULT '0',
        bdr_type smallint DEFAULT '0',
        btm_padding smallint DEFAULT '2',
        bg_color_sp smallint DEFAULT '0',
        bdr_type_sp smallint DEFAULT '0',
        btm_padding_sp smallint DEFAULT '2',
        primary key (pageu_code)
				)TYPE = InnoDB DEFAULT CHARSET=utf8;";
			//mysql 5.5対応
			if(isset($db->dbversion) && version_compare($db->dbversion,"5.0.0", ">=")){
			//mysql5.0以上の時はTYPEをENGINEに置換え
				foreach((array)$sql as $k => $v){
					$sql[$k] = str_replace('TYPE = InnoDB','ENGINE = InnoDB', $v);
				}
			}
			break;
		default:
			return false;
			break;
	}
	//sqlの実行
	if(!is_array($sql)||!count($sql)>0) {
		//テーブルのないモジュール、ユニットは存在させない
		return false;
	}
	foreach($sql as $key => $val) {
		if(!$db->query($val)) {
			return false;
		}
	}
	return true;
}
?>